SystemOrganization addCategory: #LoadOrderTests!

!WriteStream methodsFor: '*loadordertests' stamp: 'jgf 2/6/2009 12:01'!
show: aString

	^self nextPutAll: aString.
	! !

Object subclass: #SeasideLoadOrderTests
	instanceVariableNames: 'userName password komHttpServer baseTests baseUndeclared doTests seaside30 versions currentVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LoadOrderTests'!

!SeasideLoadOrderTests commentStamp: 'jgf 2/6/2009 12:08' prior: 0!
SeasideLoadOrderTests provides a single class that loads the packages described on the LoadOrder Wiki (http://code.google.com/p/seaside/wiki/LoadOrder), and shows the errors and undefined along the way.!

!SeasideLoadOrderTests classSide methodsFor: 'initialization' stamp: 'tbn 9/2/2009 23:10'!
initialize

	(UIManager default confirm: 'Load Seaside 3.0?') ifTrue: [
		self new doLoad.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/7/2010 10:13'!
adminToolsPackages

	^OrderedCollection new
		add: seaside30 -> 'Seaside-Tools-OmniBrowser-lr.17.mcz';
		add: seaside30 -> 'Seaside-Pharo-Tools-OmniBrowser-lr.6.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 20:10'!
askForTesting
	doTests := UIManager default confirm: 'Run tests as packages are loaded?'.
	doTests ifTrue: [
		baseTests := TestCase suite tests.
		baseUndeclared := Undeclared keys.
	].! !

!SeasideLoadOrderTests methodsFor: 'packages-basic' stamp: 'JamesFoster 4/27/2010 09:42'!
basicPackages

	^OrderedCollection new
		add: self greasePackages;			"Platform"
		add: self corePackages;			"Core"
		add: self canvasPackages;			"Canvas"
		add: self sessionPackages;			"Session"
		add: self componentPackages;		"Component"
		add: self renderLoopPackages;		"RenderLoop"
		add: self toolsPackages;			"Tools"
		add: self widgetsPackages;			"Widgets"
		add: self environmentPackages;	"Environment"
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'repositories' stamp: 'obi 9/6/2009 20:23'!
cacheRepositories
	seaside30 := self seaside30.
	self cacheVersionsFor: seaside30.
	komHttpServer := self komHttpServer.
	self cacheVersionsFor: komHttpServer.! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 19:56'!
cacheVersionsFor: aRepository
	self versions at: aRepository put: aRepository allVersionNames! !

!SeasideLoadOrderTests methodsFor: 'packages-basic' stamp: 'JamesFoster 9/7/2010 09:37'!
canvasPackages

	^Array 
		with: seaside30 -> 'Seaside-Canvas-pmm.100.mcz'
		with: seaside30 -> 'Seaside-Pharo-Canvas-lr.3.mcz'
		with: seaside30 -> 'Seaside-Tests-Canvas-lr.50.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/7/2010 09:34'!
comanchePackages

	^OrderedCollection new
		add: komHttpServer	-> 'DynamicBindings-lr.13.mcz';
		add: komHttpServer	-> 'KomServices-lr.20.mcz';
		add: komHttpServer	-> 'KomHttpServer-lr.52.mcz';
			
		add: seaside30		-> 'Seaside-Adaptors-Comanche-pmm.63.mcz';
		add: seaside30		-> 'Seaside-Tests-Adaptors-Comanche-lr.13.mcz';
		yourself.
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/7/2010 09:32'!
cometPackages

	^OrderedCollection new
		add: seaside30 -> 'Comet-Core-lr.51.mcz';
		add: seaside30 -> 'Comet-Pharo-Core-lr.6.mcz';
		add: seaside30 -> 'Comet-Tests-Core-lr.10.mcz';
		add: seaside30 -> 'Comet-Examples-lr.21.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages-basic' stamp: 'JamesFoster 9/7/2010 09:38'!
componentPackages

	^Array 
		with: seaside30 -> 'Seaside-Component-pmm.85.mcz'
		with: seaside30 -> 'Seaside-Tests-Component-NickAger.31.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'utility' stamp: 'jgf 2/6/2009 09:08'!
condenceChanges
"
	SeasideLoadOrderTests new condenseChanges.
"
	Smalltalk condenseChanges.
	! !

!SeasideLoadOrderTests methodsFor: 'packages-traditional' stamp: 'JamesFoster 4/27/2010 10:05'!
continuationPackages

	^Array 
		with: seaside30 -> 'Seaside-Pharo-Continuation-lr.5.mcz'
		with: seaside30 -> 'Seaside-Tests-Pharo-Continuation-lr.7.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'packages-basic' stamp: 'JamesFoster 9/7/2010 09:39'!
corePackages

	^Array 
		with: seaside30 -> 'Seaside-Core-pmm.660.mcz'
		with: seaside30 -> 'Seaside-Pharo-Core-pmm.9.mcz'
		with: seaside30 -> 'Seaside-Tests-Core-pmm.198.mcz'
		with: seaside30 -> 'Seaside-Tests-UTF8-lr.9.mcz'
		with: seaside30 -> 'Seaside-Tests-Pharo-Core-pmm.14.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'accessing' stamp: 'obi 9/6/2009 20:48'!
currentVersions
	currentVersions ifNil: [currentVersions := MCWorkingCopy allManagers collect: [:ea |  ea ancestry ancestorString ]].
	^currentVersions! !

!SeasideLoadOrderTests methodsFor: 'packages-traditional' stamp: 'JamesFoster 9/7/2010 09:35'!
developmentPackages

	^Array 
		with: seaside30 -> 'Seaside-Development-lr.139.mcz'
		with: seaside30 -> 'Seaside-Pharo-Development-lr.43.mcz'
		with: seaside30 -> 'Seaside-Tests-Development-lr.35.mcz'
		with: seaside30 -> 'Seaside-Tests-Pharo-Development-DaleHenrichs.13.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'JamesFoster 11/1/2009 13:22'!
doLoad
	self requestUserAndPassword.
	self askForTesting.
	self cacheRepositories.
	self groups do: [:aList | 
		self 
			loadPackages: aList;
			doTests;
			yourself.
	].
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'JamesFoster 11/1/2009 13:23'!
doLoadNewest
	self askForTesting.
	self cacheRepositories.
	self groups do: [:aList | 
		self 
			loadNewestPackages: aList;
			doTests;
			yourself.
	].
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 16:12'!
doTests

	| suite result |
	doTests ifFalse: [^self].
	suite := TestCase suite.
	baseTests do: [:oldTest | 
		| duplicate |
		duplicate := suite tests detect: [:newTest | newTest class == oldTest class and: [newTest selector == oldTest selector]].
		suite tests remove: duplicate.
	].
	result := suite run.
	Transcript cr; tab; show: result printString.
	result defects do: [:each | 
		Transcript cr; tab; tab; show: each printString.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 4/27/2010 10:04'!
emailPackages

	^OrderedCollection new
		add: seaside30 -> 'Seaside-Email-lr.15.mcz';
		add: seaside30 -> 'Seaside-Tests-Email-lr.9.mcz';
		add: seaside30 -> 'Seaside-Pharo-Email-lr.6.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages-basic' stamp: 'JamesFoster 9/7/2010 09:38'!
environmentPackages

	^Array 
		with: seaside30 -> 'Seaside-Environment-pmm.71.mcz'
		with: seaside30 -> 'Seaside-Pharo-Environment-lr.6.mcz'
		with: seaside30 -> 'Seaside-Tests-Environment-pmm.24.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'packages-traditional' stamp: 'JamesFoster 7/15/2010 15:05'!
examplePackages

	^Array 
		with: seaside30 -> 'Seaside-Examples-lr.19.mcz'
		with: seaside30 -> 'Seaside-Tests-Examples-lr.9.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 20:34'!
extractPackageName: fullPackageName
	^(fullPackageName findTokens: '.') first copyUpToLast: $-! !

!SeasideLoadOrderTests methodsFor: 'packages-traditional' stamp: 'JamesFoster 9/7/2010 09:38'!
flowPackages

	^Array 
		with: seaside30 -> 'Seaside-Flow-jf.22.mcz'
		with: seaside30 -> 'Seaside-Pharo-Flow-lr.5.mcz'
		with: seaside30 -> 'Seaside-Tests-Flow-jf.28.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'packages-traditional' stamp: 'JamesFoster 9/7/2010 10:07'!
functionalTestPackages

	^Array 
		with: seaside30 -> 'Seaside-Tests-Functional-pmm.124.mcz'
		with: seaside30 -> 'Seaside-Tests-Pharo-Functional-lr.12.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'packages-basic' stamp: 'JamesFoster 9/7/2010 09:33'!
greasePackages

	^Array 
		with: seaside30 -> 'Grease-Core-pmm.47.mcz'
		with: seaside30 -> 'Grease-Pharo-Core-lr.27.mcz'
		with: seaside30 -> 'Grease-Tests-Core-pmm.60.mcz'
		with: seaside30 -> 'Grease-Tests-Pharo-Core-pmm.8.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'lr 5/13/2010 12:08'!
groups

	^OrderedCollection new
		addAll: self basicPackages;
		addAll: self traditionalPackages;
		add: self adminToolsPackages;
		add: self rssPackages;
		add: self javascriptPackages;
		add: self jQueryPackages;
		add: self prototypePackages;
		add: self scriptaculousPackages;
		add: self htmlPackages;
		add: self internetExplorerPackages;
		add: self emailPackages;
		add: self comanchePackages;
		add: self cometPackages;
		add: self slimePackages;
		yourself.
		! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/7/2010 09:36'!
htmlPackages

	^OrderedCollection new
		add: seaside30 -> 'Seaside-HTML5-lr.11.mcz';
		add: seaside30 -> 'Seaside-Tests-HTML5-pmm.17.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'initialize-release' stamp: 'obi 9/6/2009 20:22'!
initialize

	super initialize.
	userName := ''.
	password := ''.


	
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/7/2010 09:36'!
internetExplorerPackages

	^OrderedCollection new
		add: seaside30 -> 'Seaside-InternetExplorer-pmm.7.mcz';
		add: seaside30 -> 'Seaside-Tests-InternetExplorer-lr.9.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 20:49'!
isPackageLoaded: aPackageName
	^self currentVersions includes: aPackageName! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/7/2010 09:33'!
jQueryPackages

	^OrderedCollection new
		add: seaside30 -> 'JQuery-Core-lr.107.mcz';
		add: seaside30 -> 'JQuery-Tests-Core-lr.123.mcz';
		add: seaside30 -> 'JQuery-UI-lr.62.mcz';
		add: seaside30 -> 'JQuery-Tests-UI-lr.78.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 7/15/2010 15:04'!
javascriptPackages
	^ OrderedCollection new
		add: seaside30 -> 'Javascript-Core-lr.88.mcz';
		add: seaside30 -> 'Javascript-Pharo-Core-DaleHenrichs.9.mcz';
		add: seaside30 -> 'Javascript-Tests-Core-lr.58.mcz';
		add: seaside30 -> 'Javascript-Tests-Pharo-Core-lr.1.mcz';
		yourself! !

!SeasideLoadOrderTests methodsFor: 'repositories' stamp: 'jgf 2/6/2009 09:15'!
komHttpServer

	^MCHttpRepository
		location: 'http://www.squeaksource.com/KomHttpServer'
		user: userName
		password: password.
! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 20:29'!
latestVersionForPackage: aName repository: repo
	| sortedVersions |
	sortedVersions := self sortedVersionsForPackage: aName repository: repo.
	^sortedVersions isEmpty
		ifTrue: [nil]
		ifFalse: [sortedVersions last]! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'obi 9/9/2009 21:34'!
loadNewestPackage: aString from: aRepository
	| packageName |
	packageName := self latestVersionForPackage: (self extractPackageName: aString) repository: aRepository.
	packageName ifNotNil: 
		[(self isPackageLoaded: packageName) ifFalse: [
				Transcript cr.
				packageName := packageName , '.mcz'.
				self loadPackage: packageName from: aRepository]]
	! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'obi 9/9/2009 21:34'!
loadNewestPackages: aList

	aList do: [:assoc |
		self
			loadNewestPackage: assoc value 
			from: assoc key.
	].
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'JamesFoster 12/15/2009 09:52'!
loadPackage: aString from: aRepository

	| version repositoryGroup transcript stream |
	version := aRepository loadVersionFromFileNamed: aString.
	transcript := Transcript.
	stream := WriteStream on: String new.
	[
		Transcript := stream.
		version load.
	] ensure: [
		Transcript := transcript.
	].
	false ifTrue: [self reportToTranscript: stream contents].
	repositoryGroup := version workingCopy repositoryGroup.
	repositoryGroup addRepository: aRepository.
	Transcript cr; show: 'Loaded ' , aString.
	self showUndeclared.
	! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 11:23'!
loadPackages: aList

	Transcript cr.
	aList do: [:assoc |
		self
			loadPackage: assoc value 
			from: assoc key.
	].
! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/7/2010 09:34'!
prototypePackages

	^OrderedCollection new
		add: seaside30 -> 'Prototype-Core-lr.22.mcz';
		add: seaside30 -> 'Prototype-Tests-Core-lr.11.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages-basic' stamp: 'JamesFoster 4/27/2010 09:39'!
renderLoopPackages

	^Array 
		with: seaside30 -> 'Seaside-RenderLoop-lr.72.mcz'
		with: seaside30 -> 'Seaside-Tests-RenderLoop-lr.11.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'JamesFoster 12/15/2009 09:52'!
reportToTranscript: aString

	| list flag |
	list := aString subStrings: (Array with: $().
	list := list collect: [:each | each withBlanksTrimmed].
	list := list reject: [:each | each isEmpty].
	list := list reject: [:each | 
		16 < each size and: [ (each copyFrom: each size - 14 to: each size) = ' is Undeclared)'].
	].
	list isEmpty ifTrue: [^self].
	flag := true.
	1 to: list size - 1 by: 2 do: [:i | 
		flag := flag and: [(list at: i) = 'a MCClassDefinition'].
	].
	flag ifTrue: [^self].
	Transcript nextPutAll: aString.
	! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 20:10'!
requestUserAndPassword
	userName := UIManager default
		request: 'SqueakSource User Name (empty is fine)?'
		initialAnswer: ''.
	password := UIManager default
		request: 'SqueakSource Password (empty is fine)?'
		initialAnswer: ''.
	! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 9/7/2010 09:34'!
rssPackages

	^OrderedCollection new
		add: seaside30 -> 'RSS-Core-pmm.62.mcz';
		add: seaside30 -> 'RSS-Tests-Core-pmm.26.mcz';
		add: seaside30 -> 'RSS-Examples-lr.24.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 7/8/2010 11:58'!
scriptaculousPackages

	^OrderedCollection new
		add: seaside30 -> 'Scriptaculous-Core-lr.96.mcz';
		add: seaside30 -> 'Scriptaculous-Tests-Core-lr.56.mcz';
		add: seaside30 -> 'Scriptaculous-Components-obi.105.mcz';
		add: seaside30 -> 'Scriptaculous-Tests-Components-lr.33.mcz';
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'repositories' stamp: 'tbn 9/2/2009 23:10'!
seaside30

	^MCHttpRepository
		location: 'http://www.squeaksource.com/Seaside30'
		user: ''
		password: ''.
! !

!SeasideLoadOrderTests methodsFor: 'packages-basic' stamp: 'JamesFoster 9/7/2010 09:39'!
sessionPackages

	^Array 
		with: seaside30 -> 'Seaside-Session-pmm.134.mcz'
		with: seaside30 -> 'Seaside-Tests-Session-lr.42.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'load and test' stamp: 'jgf 2/6/2009 16:12'!
showUndeclared

	| newUndeclared |
	doTests ifFalse: [^self].
	newUndeclared := Undeclared keys.
	baseUndeclared do: [:each | newUndeclared remove: each].
	newUndeclared isEmpty ifTrue: [^self].
	Transcript cr; tab; show: 'Undeclared: ' , newUndeclared asSortedCollection asArray printString.
	! !

!SeasideLoadOrderTests methodsFor: 'packages' stamp: 'JamesFoster 7/8/2010 12:00'!
slimePackages
	^ (Smalltalk hasClassNamed: #RBLintRule)
		ifFalse: [ OrderedCollection new ]
		ifTrue: [
			OrderedCollection new
				add: seaside30 -> 'Grease-Slime-jok.5.mcz';
				add: seaside30 -> 'Seaside-Slime-lr.78.mcz';
				add: seaside30 -> 'Grease-Tests-Slime-jok.5.mcz';
				add: seaside30 -> 'Seaside-Tests-Slime-lr.42.mcz';
				yourself ]! !

!SeasideLoadOrderTests methodsFor: 'private' stamp: 'obi 9/6/2009 19:59'!
sortedVersionsForPackage: aName repository: repo 
	| sortedVersions | 
	sortedVersions := ((versions at: repo ifAbsent: [#()]) select: [:versionName | | parts |
							parts := (aName occurrencesOf: $-) + 1.
							(versionName beginsWith: aName) and: [parts = (versionName occurrencesOf: $-) ] ])
								asSortedCollection: [:a :b | (a copyAfterLast: $.) asNumber <= (b copyAfterLast: $.) asNumber].
	sortedVersions isEmpty ifTrue: [self inform: 'No Version for ' , aName , ' found!!'. ^#() ].
	^sortedVersions! !

!SeasideLoadOrderTests methodsFor: 'packages-basic' stamp: 'JamesFoster 7/8/2010 12:02'!
toolsPackages

	^Array
		with: seaside30 -> 'Seaside-Tools-Core-jf.18.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'packages-traditional' stamp: 'JamesFoster 4/27/2010 09:59'!
traditionalPackages

	^OrderedCollection new
		add: self functionalTestPackages ;		"Functional Tests"	
		add: self continuationPackages;			"Continuations"
		add: self flowPackages;					"Flow"
		add: self webToolsPackages;			"WebTools"
		add: self developmentPackages;		"Development"
		add: self examplePackages;			"Examples"
		yourself.! !

!SeasideLoadOrderTests methodsFor: 'accessing' stamp: 'obi 9/6/2009 19:56'!
versions
	versions ifNil: [versions := Dictionary new].
	^versions! !

!SeasideLoadOrderTests methodsFor: 'packages-traditional' stamp: 'JamesFoster 9/7/2010 09:40'!
webToolsPackages

	^Array 
		with: seaside30 -> 'Seaside-Tools-Web-obi.92.mcz'
		with: seaside30 -> 'Seaside-Pharo-Tools-Web-pmm.22.mcz'
		with: seaside30 -> 'Seaside-Tests-Tools-Web-lr.15.mcz'.
! !

!SeasideLoadOrderTests methodsFor: 'packages-basic' stamp: 'JamesFoster 5/24/2010 12:49'!
widgetsPackages

	^Array
		with: seaside30 -> 'Seaside-Widgets-obi.18.mcz'.
! !
SeasideLoadOrderTests initialize!
